'''
    run.py v0.1 - runtime for a AIML bot
    author: noidfumbler from alogs/robowaifu,
            partially based on some other run.py scripts

    this file is still messy, work in progress...
    dir needs to be the one in the line with os.getcwd()
    it needs the std-startup.xml in the same dir
    the aiml-files in the same dir should be loaded at start
    also, this has only been tested under GNU + Linux (Raspian)
    to access functions in the shell with -i, comment run_kernel() out
'''

import aiml
import os

if os.getcwd() != "/home/pi/AIML":
    os.chdir("/home/pi/AIML/")

kernel = aiml.Kernel()

def get_std_startup_lines():
    '''
        returns a parsed version of the std-startup.xml file
        using this file and it a place should be a constant
        otherwise, file option to be implemented
    '''
    file = open(str(os.getcwd() + '/std-startup.xml'))
    globals()['std_startup_xml_lines'] = str(file.read()).split('</template>\n')
    file.close()
    return std_startup_xml_lines

def importfiles():
    '''
        importing all aiml files, not necessary if "Learn more" is being used
        but it also rewrites std-startup.xml, so that files will part of it
        warning: changes can overwrite your startup file with gibberish if bad code
    '''
    get_std_startup_lines()
    file_splitted = std_startup_xml_lines #to keep var name short
    ind = '            '
    lines = ''
    list_dir = os.listdir()
    output_list = []
    for element in list_dir:
        if element.endswith('aiml') and file_splitted[0].find(element) == -1:
            output_list.append(''.join(str(ind + '<learn>' + element.lstrip() + '</learn>\n')))
    lines = ''.join(output_list)
    out = (file_splitted[0].rstrip() + '\n' + lines + '        ' + '</template>\n' + file_splitted[1])
    file = open(str(os.getcwd() + '/std-startup.xml'),'w')
    file.write(out)
    file.close()

def aiml_files_list():
    '''
       returns list of aiml files (path+name) loaded at startup
       these files are the knowledge of the bot at startup
       it can learn more through other ways while running
    '''
    std_startup_xml_lines = get_std_startup_lines()
    std_startup_xml_lines = std_startup_xml_lines[0].split('\n')
    file_list = [] #result
    for line in std_startup_xml_lines:
        if len(line[:-8]) > 4 and line[:-8].endswith('aiml'):
            current_line = line[:-8].lstrip()[7:] #strips space + '<learn>'
            if current_line.startswith('/'):
                file_list.append(current_line)
            else:
                file_list.append(os.getcwd() + '/' + current_line)
        else: # debugging, can be deleted
            print('debug: line ignored: ' + line)
    return file_list

def write_knowledge_list():
    '''
        writes the output of aiml_files_list() to current dir
        filename might matter to other programs
    '''
    with open(str(os.getcwd() + '/knowledge_list') ,'w') as file:
         for line in aiml_files_list():
             file.write(line + '\n')
    file.close()

importfiles()

if os.path.isfile("bot_brain.brn"):
    kernel.bootstrap(brainFile = "bot_brain.brn")
else:
    kernel.bootstrap(learnFiles = "std-startup.xml", commands = "load aiml b")
    #kernel.saveBrain("bot_brain.brn") not in use for now

# session handling
# Get session info as dictionary. Contains the input
# and output history as well as any predicates known
sessionId = 12345
kernel.setPredicate("cat", "Nina", sessionId)

# kernel now ready for use
def run_kernel():
    '''
        the kernel of the bot, loop of read and respond
    '''
    while True:
        message = input("Enter your message >> ")
        if message == "quit":
            exit()
        elif message == "save":
            kernel.saveBrain("bot_brain.brn")
        elif message == "reload":
            kernel.respond("load aiml b")
        elif message == "session":
            sessionData = kernel.getSessionData(sessionId)
            print(sessionData)
        else:
            print(kernel.respond(message))

#run_kernel()

## ToDo
# start option without run_kernel(), getopts
# Normalisation of inputs, with external lib?
# tracing responses, for debugging (Pandorabots does it somehow)
# remembering already answered questions ...
# maybe by creating new categories, then learning on the fly
# links to some inventory, probably graph or at least lists
# maybe learning certain files as soon as they appear
# using learning for temporary overrides using priorities ^,_,#
# note: HELLO # > HELLO _ > HELLO THERE > HELLO ^ > HELLO *
# let the run script call several bots at once
# run.py should self-construct, based on options and existing files
